// Metric: 0 - Chars only -- see pCustButt.cc for Metric of 6 -- Pixels.

// See comments below regarding translations ...:
#include <custButtEnglish.h>    // completed
//#include <custButtItalian.h>    // completed
//#include <custButtGerman.h>     // completed
//#include <custButtDanish.h>     // completed
//#include <custButtNorwegian.h>  // completed
//#include <custButtFrench.h>     // completed
//#include <custButtCatalan.h>    // completed
//#include <custButtSpanish.h>    // completed
//#include <custButtPortuguese.h> // completed
//#include <custButtTurkish.h>    // completed
//#include <custButtSwedish.h>    // completed

// ------------------------------------------------
// Height/Width of buttons based on Manifest
// file being used or not. Unfortunately,
// the only way to make this work is
// to comment/uncomment code -- in this case
// if you are NOT using a Manifest file,
// comment out the next statement:
#define Manifest true

#ifdef Manifest
   // Manifest file sizes:
	#define kmHEIGHT 1.36
	#define kmWIDTH  4.57
#else
  // No manifest file, use 'old' settings:
  #define kmHEIGHT 1.2
  #define kmWIDTH  3.6
#endif
// ------------------------------------------------

/*
   --------------------------------------------------------
   CUSTBUTT.CC 
   Author...: Ken Mayer
   Date.....: February 25, 1999
   Notes....: Ken's Custom Button Class, re-done for
   Visual dBASE 7, and cut back to just the toolbar-style
   buttons, as that's all I ever use ... 
      Note that some of the code was lifted from work by
      the "Samples Group" here at Borland in the toolbutton
      programs in the samples directories.

   NOTE: If you are using a version of this file prior
   to release DUFLP2KC, there may be problems with FILTER
   and EMPTYTABLE preprocessor directives. If you are using
   this version, make sure you update your header file ...

   ***********************************************************
   ***********************************************************
   * September/October 2005:
   * dBASE Plus 2.6, while allowing nifty new functionality
   * or appearance using Windows XP Themes/Styles, did something
   * to the way that pushbuttons that have the SpeedBar property
   * set to true, disabling that functionality.
   * This was fixed in dBASE Plus 2.61.
   * However, at least on my machine the buttons need to be
   * a little larger to view the images. So I modified
   * the code for the toolbars to calculate their size
   * based on the size of the buttons. However, if you
   * already have forms using these controls, you may need
   * to do some readjustment of the size of the containers ...
   ***********************************************************

   ***********************************************************
   ***********************************************************
   * IMPORTANT: as of Feb. 25, 1999, these buttons
   * require the use of a header file. This file defaults
   * to English (custButtEnglish.h). However, if you are
   * using another language other than English, you 
   * can change the speedTips and message dialog text
   * for these simply by changing the header file in the
   * #include statement above to the appropriate file. 
   * Keep in mind that when you do this, you MUST recompile
   * custbutt.cc (COMP CUSTBUTT.CC in the command window ...)
   * or you will not see any changes ... 
   * *** To use this properly, you may wish to copy
   * the header file or files you need to use to the
   * local directory, or better to the ..\dBASE\INCLUDE
   * directory ...
   ************************************************************
   ***********************************************************

   UPDATED..: 06/28/1998 by Ken:
               Added kmCarryButton
              10/26/1998 by Ken:
               Changed the rowsetState object from
               the text object to Gary White's custom
               entryfield object -- by using this, which
               creates a calculated field in the rowset
               specifically used to update the entryfield.
               It should look otherwise like normal, but
               it should also be a bunch faster, because
               the entryfield does not attempt to render
               HTML, and there is no need for each pushbutton
               to update the control.
              11/02/1998 by Ken:
               Based on reports by Jay C. Heil on the
               VdBASE newsgroups, the kmCarryButton control 
               has been modified to better handle _dBASELock
               fields, as well as fields that use the 
               lookupSQL property. (Tested against the
               customer table (customer.dmd) in the samples 
               directory (mugs), after issuing a CONVERT to 
               ensure that there was a lockfield, it uses 
               the lookupSQL on the stateid field ...)
              11/20/1998 by Ken:
               Added code posted in Visual dBASE newsgroups
               for kmFilterButton (which up until now
               has not had code associated with it).
               The filter button will set your form
               to a filter-by-form mode (beginFilter() ),
               change the image to "Run", which is then
               used to apply the "applyFilter()" method,
               and if no match is found, returns an 
               error, and finally changes to a clearFilter
               mode ... Code by Santo Lo Galbo in Italy.
             11/23/1998 -- more code mods provided by 
               Santo Lo Galbo ...
             12/30/1998 -- Minor mods based on observations
               by Richard Clark ...
             01/05/1999 -- Copied the kmSearchButton to
               kmLocateButton and added code by Santo Lo Galbo ...
               Added necessary mods to other buttons to check
               rowset's state ...

               Added other code based on some stuff Gary White
               helped with for the VDB7 Tutorial Project ...
               Buttons that assume rowsets now check the
               state, and if clicking the button would
               cause a problem, offers the user the choice
               to save, abandon or cancel ...

             Jan. 13-15, 1999 -- Added code by Peter Rorlick
               to give an optional rowset property which
               can be used with buttons that rely on/manipulate 
               the rowset. This allows the same button to 
               manipulate different rowsets on the same form
               by simply changing the rowset, i.e.,
                  form.kenstoolbar1.navigateButtons.kmTopButton1.rowset :=;
                     form.datamodref1.ref.query2.rowset

               ** Note that this requires a change if you are 
                  switching the form's rowset property, you
                  need to change the toolbar's buttons references
                  by using the initRowset method for either
                  kensToolbar or kmToolBar2:
                     form.kensToolbar1.rowset := form.query2.rowset
                     form.KensToolbar1.initRowset()
                  otherwise the buttons may be pointing to the
                  wrong rowset ...

             Jan 18, 1999 -- Minor fix by Santo for the
                onRightMouseDown button ... added the
                clearFilter call there.

             February 9, 1999 -- Added some error trapping
                in the kmCustFilter and kmCustLocate buttons
                to handle memo fields. Code once again
                by Santo ...

             February 25, 1999 -- Added header files so that
                this can be used by non-English applications
                with the only change being the header file
                used. See notes under "DEPENDENCIES"
                below ...

             October 20, 1999 -- More error trapping added
                to the kmFilter button code by Ronnie MacGregor.

             July 2001 -- A re-write of the initRowset method for 
                the toolbars by Ronnie MacGregor to deal with the 
                attempted switching of rowsets when in edit/append
                mode. This now allows one line of code to accomplish
                the switch, and returns a logical result of the 
                attempt: 

                result = form.KensToolbar1.initRowset(form.query2.rowset)

             February, 2002 -- Addition of more variables defined
                as local, to avoid overwriting/destroying the
                users' own code ... (Bruce Beacham)

             December, 2002 -- Minor code addition to kmCustCarry
                button, make sure we don't try to copy binary
                and OLE field types.

             July, 2004 -- Added changes to allow a subclassed
                version of the button to use different images
                through the use of new properties for the 
                kmFilterButton and kmLocateButton.

             November, 2004 -- Added code in the kmEditButton
                to attempt to lock a row before editing it.
                This is vital in a networked environment,
                and should cause no issues in a single-user
                environment.

                Added code in kmSaveButton and kmAbandonButton
                to release the explicit lock created in the
                kmEditButton code, to be sure that we don't
                leave a lock just "lying around".

                Note that if the session for the rowset (there
                is one, even if you don't realize it) has
                the lockRetryCount set to a value > 0, then
                when we attempt to lock a row that already
                has a lock on it, we get a custom message,
                rather than the default "Row is locked, retrying ..."
                message. 
               
   ==============================================================
   What we have:

   -----------
   Containers:
   -----------

   KENSTOOLBAR -- A Container which holds a set of containers
     (yes, nested custom containers), each of which holds
     at least one pushbutton, and now holds an instance
     of the kmRowState object. See docs below for the
     rowState object ...

     See documentation if working with multiple rowsets
     on the same form ...

   KENSTOOLBAR2 -- Same as above, but instead of EDITBUTTONS,
     we have EDITBUTTONS2 (see below)

   NAVIGATEBUTTONS -- A Container which holds a set of
     navigation buttons. These use the current rowset
     of a form (form.rowset), and do the standard navigation
     through a table. This also holds an instance of the
     rowState object ...

   EDITBUTTONS -- A Container which holds a set of editing
     buttons. These are Append, Edit, Delete, Save, Cancel.

   EDITBUTTONS2 -- Same as EditButtons, but next to the
     Append button is an instance of kmCarryButton

   CLIPBOARDBUTTONS -- A Container which holds the standard
     clipboard Cut, Copy, Paste buttons.

   FINDBUTTONS -- A Container holding buttons (with no
     code) for Search, Search Again, and Replace

   EXITBUTTONS -- A Container holding just a single 'Exit 
      Button' (put into a container so that it looks like
      the others, as the containers are using borders, and
      so on ...

   --------
   Buttons:
   --------
   BaseSpeedButton -- this is what the other buttons
   are based on. If I need to change a shared property,
   I only have to change it here ... 

   VERY IMPORTANT NOTE: This button used to have a method 
   called refreshRowState. This method no longer exists, 
   as the rowState object is now self-contained ... all
   the buttons that called this method no longer have the
   code to call it, either. This may break any code you
   are using that is based on this -- but all you should have
   to do is remove the call to SUPER::refreshRowState() or
   whatever.


   // Many of the following use the 'split' images
   // in RESOURCE.DLL

   Navigation:
   kmTopButton      -- first row in rowset
   kmPreviousButton -- previous row ...
   kmNextButton     -- next ...
   kmEndButton      -- last

   Editing:
   kmAddButton      -- add new row
   kmEditButton     -- edit current
   kmSaveButton     -- save changes/new row
   kmDeleteButton   -- delete row
   kmAbandonButton  -- abandon changes
   kmCarryButton    -- copies current record
                       to a new one, as if using
                       SET CARRY ON and/or SET CARRY TO
                       -- see notes in header for button
   Filter-by-Form:
   kmFilterButton   -- see docs below for this --
                       this is a busy button, but
                       very nicely coded ...
   Locate-by-Form:
   kmLocateButton   -- similar to above, but for locate ...

   ClipBoard:
   kmCutButton      -- as they sound
   kmCopyButton
   kmPasteButton

   Close form:
   kmCloseButton    -- closes the current form


   // the rest of these buttons have no code, you have
   // to define it yourself:
   kmYesButton
   kmNoButton
   kmCancelButton
   kmQuestionButton
   kmLightningButton
   kmInfoButton
   kmFromDiskButton
   kmToDiskButton
   kmOpenFolderButton
   kmWrenchButton
   kmPrintButton
   kmSearchButton
   kmSearchAgainButton
   kmReplaceButton
   kmSearch2Button 
   kmExitButton   // same as 'close', but no code ...
   kmFirstPageButton
   kmNextPageButton
   kmPreviousPageButton
   kmLightBulbButton

   -----------------------
   Entryfield (fake Text):
   -----------------------
   kmRowState -- This is a copy of Gary White's modifications
   to the original control provided by Inprise. This version
   has an additional method and some other minor changes.
   It should be faster than the previous version which was
   a text control ...


   DEPENDENCIES:
     A header file -- the default is:
       custbuttEnglish.h

     The idea here is that we can change the language
     simply by changing the header file. All strings that
     are displayed to a user are contained in the header
     file, including speedTips and text in dialog boxes.
     Translations are provided by those who speak English 
     and some other language -- I don't (not well enough 
     to translate -- I haven't spoken German since High 
     School and was not very good at it then).

     The #include statements are at the top of this file
     to make it easier to find ... if you need a language
     other than English, comment out the English header
     file and uncomment the one you need. If you need
     a language that isn't covered here, feel free to
     copy one of the translated files and translate
     to the language you need. However, please provide
     a copy to the library if you do so! Thanks.

     Other versions available (translators credited in
     the .H files):
        German
        French
        Italian
        Spanish
        Catalan
        Portuguese
        Danish
        Norwegian
        Turkish
        Swedish

      *** Note: To use these effectively, your best bet
      is to copy the appropriate header file(s) to the
      ..\Visual dBASE\INCLUDE directory ...
   ----------------------------------------------------------- 
*/

/* =======================================================
   We start with some containers, which hold some of the 
   buttons defined later in this file
   ======================================================= */

/* --------------------------------------------------------
   KensToolBar
   Generic "toolbar" -- contains Navigate, Edit, Clipboard,
   Exit, and RowState.

   June 2001 Ronnie MacGregor made changes to the onOpen
   and initRowset methods to deal with an attempted change
   of rowset in mid edit/append etc.. 

   NOTE, if you change the form's rowset property to work 
   with a new rowset (i.e., a parent/child relationship, 
   or something of that sort), you need to use the 
   container's initRowset method:

   result = form.KensToolbar1.initRowset(form.query2.rowset)

   If you don't do this, the buttons and the 
   rowState object will not update properly. When you switch 
   back to the original (or another rowset), just do the 
   same as above again substituting the correct rowset
   reference.

   In previous versions the rowset property of the toolbar
   was addressed directly, before calling initRowset. Now the
   new rowset can be passed as a parameter to initRowset. The
   old method will still work for legacy code.
   -------------------------------------------------------- */

class KENSTOOLBAR(parentObj) of CONTAINER(parentObj) custom
   with (this)
      transparent := true
      // Calculate width based on width of buttons, space between
      // containers, and rowstate ...
      width       := (4 * kmWIDTH )+(3*kmWidth)+(5*kmWidth)+kmWidth+4+9.4286
      height      := 1.3636
      metric      := 0        // Chars
      colorNormal := "BtnFace"
      borderStyle := 3   // none
   endwith
   this.rowset = null

   this.NAVIGATEBUTTONS = new NAVIGATEBUTTONS(this)
   with (this.NAVIGATEBUTTONS)
      left   := 0
      top    := 0
      metric := 0        // Chars
      pageno := 0
   endwith

   this.CLIPBOARDBUTTONS = new CLIPBOARDBUTTONS(this)
   with (this.CLIPBOARDBUTTONS)
      left   := this.NavigateButtons.width+1// 15.4
      top    := 0
      metric := 0        // Chars
      pageno := 0
   endwith

   this.EDITBUTTONS = new EDITBUTTONS(this)
   with (this.EDITBUTTONS)
      left   := this.ClipboardButtons.left+this.ClipboardButtons.width+1//27
      top    := 0
      metric := 0        // Chars
      pageno := 0
   endwith


   this.EXITBUTTONS = new EXITBUTTONS(this)
   with (this.EXITBUTTONS)
      left   := this.EditButtons.left+this.EditButtons.width+1 //46
      top    := 0
      metric := 0        // Chars
      pageno := 0
   endwith

   this.RowState = new kmRowState( this )
   with ( this.RowState )
      top    := 0.2273
      left   := this.ExitButtons.left+this.ExitButtons.width+1 //50.4286
      pageNo := 0
   endwith

   function onOpen 
      // if the developer has not assigned a rowset
      // to this container, assume the form's rowset:
      if this.rowset == null
         this.rowset = form.rowset
      endif
      // June 2001 Ronnie MacGregor added the following line
      // to allow checking of the old rowset's state before
      // switching to a new rowset.
      this.oldRowset = this.rowset
      class::initRowset(this.rowset)
      return

   function initRowset(oNewRowset)
      local nState, nAnswer
      // Modifications June 2001 Ronnie MacGregor
      // This function re-written to deal better
      // with dynamic switching of rowsets.
      //
      // We now check the state of the current rowset first.
      // If we are editing/appending the current rowset, 
      // we don't want to switch to another rowset or navigate.
      //
      // This function will now accept a parameter for the new rowset,
      // although the old method of setting the rowset property
      // and calling this function with no parameter will still work.
      //
      // This function now returns a logical value to allow the
      // developer to assess the success or failure of the attempted
      // change of rowset.
      //
      if not empty(argvector(1))
         // Set the toolbar's new rowset
         this.rowset = oNewRowset
      endif
      // Check the state of the old rowset first
      // if we are editing/adding a row, we don't want 
      // to navigate.
      try
         nState = this.oldRowset.state
      catch(exception e)
         nState = 0 // no rowset assigned
      endtry
      // 
      do case
         case nState == 2 or nState == 3  // Edit Append
              if this.oldRowset.modified
                 nAnswer = msgbox(SAVECHANGES, ;
                                  DATACHANGED,32+3)
                 do case
                    case nAnswer == 6
                       this.oldRowset.save()
                    case nAnswer == 7
                       this.oldRowset.abandon()
                    otherwise
                       this.rowset = this.oldRowset
                       return false
                 endcase
              else
                 this.oldRowset.abandon()
              endif
         case nState == 4 // filter
              msgbox( INFILTERMODE,;
                      CANTNAVIGATE, 16 )
              this.rowset = this.oldRowset
              return false
         case nState == 5 // locate
              msgbox( INLOCATEMODE,;
                      CANTNAVIGATE, 16 )
              this.rowset = this.oldRowset
              return false
      endcase
      this.oldRowset = this.rowset
      // Set the component rowsets
      this.NavigateButtons.rowset := this.rowset
      this.EditButtons.rowset     := this.rowset
      this.ExitButtons.rowset     := this.rowset
      this.rowState.initRowset()
      //
      return true


endclass

/* --------------------------------------------------------
   kmToolBar2
   Generic "toolbar" -- contains Navigate, Edit2, Clipboard,
   Exit, and RowState. 

   June 2001 Ronnie MacGregor made changes to the onOpen
   and initRowset methods to deal with an attempted change
   of rowset in mid edit/append etc.. 

   NOTE, if you change the form's rowset property to work 
   with a new rowset (i.e., a parent/child relationship, 
   or something of that sort), you need to use the 
   container's initRowset method:

   result = form.KensToolbar1.initRowset(form.query2.rowset)

   If you don't do this, the buttons and the 
   rowState object will not update properly. When you switch 
   back to the original (or another rowset), just do the 
   same as above again substituting the correct rowset
   reference.

   In previous versions the rowset property of the toolbar
   was addressed directly, before calling initRowset. Now the
   new rowset can be passed as a parameter to initRowset. The
   old method will still work for legacy code.
   -------------------------------------------------------- */

class kmToolBar2(parentObj) of CONTAINER(parentObj) custom
   with (this)
      // Calculate width based on width of buttons, space between
      // containers, and rowstate ...
      width       := (4 * kmWIDTH )+(3*kmWidth)+(6*kmWidth)+kmWidth+4+9.4286
      height      := 1.4545
      transparent := true
      metric      := 0        // Chars
      colorNormal := "BtnFace"
      borderStyle := 3   // none
   endwith
   this.rowset = null

   this.NAVIGATEBUTTONS = new NAVIGATEBUTTONS(this)
   with (this.NAVIGATEBUTTONS)
      left   = 0
      top    = 0
      pageno = 0
   endwith

   this.CLIPBOARDBUTTONS = new CLIPBOARDBUTTONS(this)
   with (this.CLIPBOARDBUTTONS)
      left   = this.NavigateButtons.width+1//14.8571
      top    = 0
      pageno = 0
   endwith

   this.EDITBUTTONS = new EDITBUTTONS2(this)
   with (this.EDITBUTTONS)
      left   = this.Clipboardbuttons.left+this.ClipboardButtons.width+1
      top    = 0
      pageno = 0
   endwith

   this.EXITBUTTONS = new EXITBUTTONS(this)
   with (this.EXITBUTTONS)
      left   = this.EditButtons.left+this.EditButtons.width+1
      top    = 0
      pageno = 0
   endwith

   this.ROWSTATE = new KMROWSTATE(this)
   with (this.ROWSTATE)
      left   = this.ExitButtons.left+this.ExitButtons.width+1
      top    = 0.1818
      pageno = 0
   endwith

   function onOpen 
      // if the developer has not assigned a rowset
      // to this container, assume the form's rowset:
      if this.rowset == null
         this.rowset = form.rowset
      endif
      // June 2001 Ronnie MacGregor added the following line
      // to allow checking of the old rowset's state before
      // switching to a new rowset.
      this.oldRowset = this.rowset
      class::initRowset(this.rowset)
      return

   function initRowset(oNewRowset)
      local nState, nAnswer
      // Modifications June 2001 Ronnie MacGregor
      // This function re-written to deal better
      // with dynamic switching of rowsets.
      //
      // We now check the state of the current rowset first.
      // If we are editing/appending the current rowset, 
      // we don't want to switch to another rowset or navigate.
      //
      // This function can now accept a parameter for the new rowset,
      // although the old method of setting the rowset property
      // and calling this function with no parameter will still work.
      //
      // This function now returns a logical value to allow the
      // developer to assess the success or failure of the attempted
      // change of rowset.
      //
      if not empty(argvector(1))
         // Set the toolbar's new rowset
         this.rowset = oNewRowset
      endif
      // Check the state of the old rowset first
      // if we are editing/adding a row, we don't want 
      // to navigate.
      try
         nState = this.oldRowset.state
      catch(exception e)
         nState = 0 // no rowset assigned
         ? "No rowset" //////////////////////////////////
      endtry
      // 
      do case
         case nState == 2 or nState == 3 // Edit Append
              if this.oldRowset.modified
                 nAnswer = msgbox(SAVECHANGES, ;
                                  DATACHANGED,32+3)
                 do case
                    case nAnswer == 6
                       this.oldRowset.save()
                    case nAnswer == 7
                       this.oldRowset.abandon()
                    otherwise
                       this.rowset = this.oldRowset
                       return false
                 endcase
              else
                 this.oldRowset.abandon()
              endif
         case nState == 4 // filter
              msgbox( INFILTERMODE,;
                      CANTNAVIGATE, 16 )
              this.rowset = this.oldRowset
              return false
         case nState == 5 // locate
              msgbox( INLOCATEMODE,;
                      CANTNAVIGATE, 16 )
              this.rowset = this.oldRowset
              return false
      endcase
      this.oldRowset = this.rowset
      // Set the component rowsets
      this.NavigateButtons.rowset := this.rowset
      this.EditButtons.rowset     := this.rowset
      this.ExitButtons.rowset     := this.rowset
      this.rowState.initRowset()
      //
      return true
      
endclass

/* --------------------------------------------------------
   Navigation Buttons Container
   Top, Previous, Next, End

   NOTE: if you use this container by itself, without
   the kensToolbar or kmToolBar2 containers as parent,
   and you work with multiple rowsets on a form,
   you may want to do something like:

        form.navigateButtons1.rowset = form.query2.rowset
   -------------------------------------------------------- */
class NavigateButtons(parentObj) of CONTAINER(parentObj) custom
   with (this)
      transparent := true
      width       := (4 * kmWIDTH ) //15.14
      height      := 1.44
      metric      := 0
      colorNormal := "BtnFace"
      borderStyle := 3   // none
   endwith
   this.rowset = null

   this.KMTOPBUTTON1 = new KMTOPBUTTON(this)
   with (this.KMTOPBUTTON1)
      left   := 0
      top    := 0
   endwith

   this.KMPREVIOUSBUTTON1 = new KMPREVIOUSBUTTON(this)
   with (this.KMPREVIOUSBUTTON1)
      top    := 0
      left   := width
   endwith

   this.KMNEXTBUTTON1 = new KMNEXTBUTTON(this)
   with (this.KMNEXTBUTTON1)
      left   := 2*width
      top    := 0
   endwith

   this.KMENDBUTTON1 = new KMENDBUTTON(this)
   with (this.KMENDBUTTON1)
      left   := 3*width
      top    := 0
   endwith

endclass

/* --------------------------------------------------------
   Edit Buttons Container
   Add, Edit, Save, Abandon, Delete

   NOTE: if you use this container by itself, without
   the kensToolbar or kmToolBar2 containers as parent,
   and you work with multiple rowsets on a form,
   you may want to do something like:

        form.EditButtons1.rowset := form.query2.rowset
   -------------------------------------------------------- */
class EditButtons(parentObj) of CONTAINER(parentObj) custom
   with (this)
      transparent := true
      width       := (5*kmWidth)
      height      := 1.44
      metric      := 0	// Chars
      colorNormal := "BtnFace"
      borderStyle := 3   // none
   endwith
   this.rowset = null

   this.KMADDBUTTON1 = new KMADDBUTTON(this)
   with (this.KMADDBUTTON1)
      left  := 0
      top   := 0
   endwith

   this.KMEDITBUTTON1 = new KMEDITBUTTON(this)
   with (this.KMEDITBUTTON1)
      top   := 0
      left  := width //3.5714
   endwith

   this.KMSAVEBUTTON1 = new KMSAVEBUTTON(this)
   with (this.KMSAVEBUTTON1)
      left  := 2*width //7.1429
      top   := 0
   endwith

   this.KMABANDONBUTTON1 = new KMABANDONBUTTON(this)
   with (this.KMABANDONBUTTON1)
      left  := 3*width //10.7143
      top   := 0
   endwith

   this.KMDELETEBUTTON1 = new KMDELETEBUTTON(this)
   with (this.KMDELETEBUTTON1)
      left := 4*width // 14.29
      top  := 0
   endwith

endclass

/* --------------------------------------------------------
   EditButtons2 -- has an instance of kmCarryButton
   Add, Carry, Edit, Save, Abandon, Delete

   NOTE: if you use this container by itself, without
   the kensToolbar or kmToolBar2 containers as parent,
   and you work with multiple rowsets on a form,
   you may want to do something like:

        form.EditButtons21.rowset = form.query2.rowset
   -------------------------------------------------------- */

class EditButtons2(parentObj) of CONTAINER(parentObj) custom
   with (this)
      transparent := true
      width       := (6*kmWidth)
      height      := 1.44
      metric      := 0	// Chars
      colorNormal := "BtnFace"
      borderStyle := 3   // none
   endwith
   this.rowset = null

   this.kmAddButton1 = new KMADDBUTTON(this)
   with (this.KMADDBUTTON1)
      left  := 0
      top   := 0
   endwith

   this.kmCarryButton1 = new KMCARRYBUTTON(this)
   with (this.KMCARRYBUTTON1)
      left = width //3.5714
      top  = 0
   endwith

   this.kmEditButton1 = new kmEditButton(this)
   with (this.KMEDITBUTTON1)
      left = 2*width //7.1429
      top  = 0
   endwith

   this.kmSaveButton1 = new kmSaveButton(this)
   with (this.KMSAVEBUTTON1)
      left = 3*width // 10.7143
      top  = 0
   endwith

   this.kmAbandonButton1 = new kmAbandonButton(this)
   with (this.KMABANDONBUTTON1)
      left = 4*width // 14.2857
      top  = 0
   endwith

   this.kmDeleteButton1 = new kmDeleteButton(this)
   with (this.KMDELETEBUTTON1)
      left = 5*width //17.8571
      top  = 0
   endwith

endclass


/* --------------------------------------------------------
   Clipboard Buttons
   Cut, Copy, Paste
   -------------------------------------------------------- */
class ClipBoardButtons(parentObj) of CONTAINER(parentObj) custom
   with (this)
      transparent := true
      width       := (3*kmWidth)
      height      := 1.44
      metric      := 0
      colorNormal := "BtnFace"
      borderStyle := 3   // none
   endwith

   this.KMCUTBUTTON1 = new KMCUTBUTTON(this)
   with (this.KMCUTBUTTON1)
      left := 0
      top  := 0
   endwith

   this.KMCOPYBUTTON1 = new KMCOPYBUTTON(this)
   with (this.KMCOPYBUTTON1)
      left := width //3.57
      top  := 0
   endwith

   this.KMPASTEBUTTON1 = new KMPASTEBUTTON(this)
   with (this.KMPASTEBUTTON1)
      left := 2*width //7.14
      top  := 0
   endwith

endclass

/* --------------------------------------------------------
   Search Buttons
   Search, Replace, Search Again

   NOTE: These buttons have no code -- you would need
   to associate code with them. 

   You may want to use, instead, kmFilterButton or
   kmLocateButton ...
   -------------------------------------------------------- */
class FindButtons(parentObj) of CONTAINER(parentObj) custom
   with (this)
      transparent := true
      width       := (3*kmWidth)
      height      := 1.44
      metric      := 0
      colorNormal := "BtnFace"
      borderStyle := 3   // none
   endwith

   this.KMSEARCHBUTTON1 = new KMSEARCHBUTTON(this)
   with (this.KMSEARCHBUTTON1)
      left := 0
      top  := 0
   endwith

   this.KMREPLACEBUTTON1 = new KMREPLACEBUTTON(this)
   with (this.KMREPLACEBUTTON1)
      left := width //3.57
      top  := 0
   endwith

   this.KMSEARCHAGAINBUTTON1 = new KMSEARCHAGAINBUTTON(this)
   with (this.KMSEARCHAGAINBUTTON1)
      left := 2*width //7.14
      top  := 0
   endwith

endclass

/* --------------------------------------------------------
   Exit Buttons
   Close 

   NOTE: if you use this container by itself, without
   the kensToolbar or kmToolBar2 containers as parent,
   and you work with multiple rowsets on a form,
   you may want to do something like:

        form.ExitButtons1.rowset := form.query2.rowset
   -------------------------------------------------------- */

class ExitButtons(parentObj) of CONTAINER(parentObj) custom
   with (this)
      transparent := true
      width       := kmWidth
      height      := 1.44
      metric      := 0
      colorNormal := "BtnFace"
      borderStyle := 3   // none
   endwith
   this.rowset = null
 
   this.KMCLOSEBUTTON1 = new KMCLOSEBUTTON(this)
   with (this.KMCLOSEBUTTON1)
      left := 0
      top  := 0
   endwith

endclass


/* =======================================================
   Now for the Button definitions themselves:
   ======================================================= */

/* =======================================================
   A Base Class: 

   NOTE: "this.rowset" property -- for those buttons that
   manipulate the rowset, this property is directly 
   addressable by the developer. The code for the
   various buttons checks to see if there is a rowset
   assigned, and if not, it assigns "form.rowset". 

   Well,that's all well and good, but ... you, the developer,
   can also directly assign a rowset to a button -- this
   can be useful if you have multiple rowsets on a form,
   and want to have two sets of buttons, one for each 
   rowset ... i.e., 
       form.kmAddButton2.rowset = form.query2.rowset

   In addition, the toolbar containers above (kensToolbar, and 
   kmToolBar2) have initRowset() methods that can be used
   to reset the rowset property of the buttons used in those
   containers to the form's rowset, which may be quite
   useful in the situation where the developer just changes
   the form's rowset reference (form.rowset = ...).
   ======================================================= */
class BaseSpeedButton( parentObj ) of PushButton( parentObj ) custom
   #if __version__ = 2.6
      // for these toolbuttons, don't use the system theme ...
      this.systemTheme := false // for dBASE Plus 2.6
   #endif
   this.text     := "" // no text
   this.metric   := 0  // Char
   this.height   := kmHEIGHT
   this.width    := kmWIDTH
   this.speedbar := true
   this.value    := false
   this.rowset   =  NULL // custom property!

   function getRowset()
      local rRowToActOn
      rRowToActOn = null // default
      // check to see if rowset property has been set:
      if this.rowset # null
         rRowToActOn = this.rowset
        // ok, this.rowset has not been set, check to see
        // if the parent has a rowset that's valid
        // (the parent will be "NavigateButtons", a container,
        // or the form):
      elseif type( "this.parent.rowset" ) == "O" and;
             this.parent.rowset # null
         rRowToActOn = this.parent.rowset
      // otherwise we check for the form's rowset:
      elseif form.rowset # null
         rRowToActOn = form.rowset
      endif
   return rRowToActOn
endclass

/* =======================================================
   First, we start with the Navigation Buttons:
   ======================================================= */

/* ---------------------------------------------------- */
class kmTopButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap := "RESOURCE:2 PS_FIRST"
   this.SpeedTip := TOPTIP

   function onClick
     local rRowToActOn, nState, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( NAVNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to navigate ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6 // yes
                         rRowToActOn.save()
                      case nAnswer == 7 // no
                         rRowToActOn.abandon()
                      otherwise         // cancel
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTNAVIGATE, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTNAVIGATE, 16 )
                return
        endcase
        rRowToActOn.first()
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmPreviousButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap := "RESOURCE:2 PS_PREV"
   this.SpeedTip := PREVTIP

   function onClick
     local rRowToActOn, nState, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( NAVNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to navigate ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTNAVIGATE, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTNAVIGATE, 16 )
                return
        endcase
        if ( not rRowToActOn.next(-1) )
           rRowToActOn.next()
           msgbox( ATFIRSTROW, ;
                   CANTNAVIGATE, 64 )
        endif
     endif

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmNextButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap := "RESOURCE:2 PS_NEXT"
   this.SpeedTip := NEXTTIP

   function onClick
     local rRowToActOn, nState, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( NAVNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to navigate ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTNAVIGATE, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTNAVIGATE, 16 )
                return
        endcase
        if ( not rRowToActOn.next() )
           rRowToActOn.next(-1)
           msgbox( ATLASTROW, ;
                   CANTNAVIGATE, 64 )
        endif
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmEndButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap := "RESOURCE:2 PS_LAST"
   this.SpeedTip := ENDTIP

   function onClick
     local rRowToActOn, nState, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( NAVNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to navigate ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTNAVIGATE, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTNAVIGATE, 16 )
                return
        endcase
        rRowToActOn.last()
     endif
endclass
/* ---------------------------------------------------- */

/* =======================================================
   Editing Buttons:
   ======================================================= */

/* ---------------------------------------------------- */
class kmAddButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap := "RESOURCE:2 PS_APPEND"
   this.SpeedTip := ADDTIP

   function onClick
     local rRowToActOn, nState, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( ADDNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to add more rows ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTADDROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTADDROW, 16 )
                return
        endcase
        rRowToActOn.beginAppend()
     endif

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmCarryButton( parentObj ) of BaseSpeedButton( parentObj ) custom
/*    Notes.: This pushbutton will act like SET CARRY ON
            in the old XBase DML -- it will copy the contents
            of the current record, EXCEPT for any autoincrement,
            lock, or read-only fields.

            In addition, there is an optional property
            called "Carry" that can be used to specify a field
            list. It is suggested that you use the custom
            button's onOpen event (which does not currently 
            have any code assigned to it) to set this property 
            to list the fields you wish to copy when the user
            clicks the button. This would cause the button
            to act like the XBase DML: 
                SET CARRY TO <fieldname>,<fieldname>, etc.
            You would do it by using in the onOpen event
            of your instance of the button:
            	 this.carry = "<fieldname>,<fieldname>, etc."

            Warning: Fields that are not datalinked will also
            be copied unless you use the custom property 
            mentioned above ...

      11/02/1998 -- Jay C. Heil found a problem with
            _DBASELOCK fields, and also with lookupSQL
            fields. He threw some suggested changes at me
            which I have implemented, and after some more
            extensive testing, they seem to work fine.

*/
   with (this)
      upBitmap := "RESOURCE #612"
      speedTip := CARRYTIP
   endwith

   function onClick
     local rRowToActOn, nState, nAnswer, lList, aCarry, lAdd
     private fFields, i
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( COPYNOROWSET,;
                CANTDOIT, 16 )
        return

     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to copy a row
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTCOPYROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTCOPYROW, 16 )
                return
        endcase

        // deal with field list (optional)
        if type( "this.Carry" ) == "C"
           lList = true
        else
           lList = false
        endif

        // array used to copy current record
        aCarry = new Array()
        // shorten the form.rowset.fields references:
        fFields = rRowToActOn.fields

        // copy current record
        for i = 1 to fFields.size
            lAdd = true
            /*
               except for readonly, autoincrement or lock 
               (_dbaseLock) fields 
                NOTE: _dbaseLock fields don't have
                     type or readOnly properties,
                     so we have to make sure that they
                     exist before we check to see what
                     is in them ... also we can't 
                     overwrite with the code here
                     any AUTOINC, OLE or BINARY field
                     values.
            */
            if ( type( "fFields[i].readOnly" ) # "U" and ;
                fFields[i].readOnly ) or ;
                  ( type ( "fFields[i].type" ) # "U" and ;
               ("AUTOINC" $ fFields[i].type or ;
                "OLE" $ fFields[i].type or ;
                "BINARY" $ fFields[i].type) ) or ;
               fFields[i].className == "LOCKFIELD"
               lAdd = false
            endif

            // fields not in this.Carry if provided ...
            if lList AND ;
               NOT upper( fFields[i].fieldName ) $ ;
                   upper( this.Carry )
               lAdd = false
            endif

            if not lAdd
               aCarry.add( "* Skip This Field *" )
            else
               /*
                  if we have a lookupRowset, then
                  we have a lookupSQL statement, and
                  we need to ensure that we store the 
                  value that needs to be stored, NOT 
                  the value that will be returned by 
                  the lookupSQL ...
               */
               if fFields[i].lookupRowset # NULL
                  aCarry.add( fFields[i].lookupRowset.fields[2].value )
               else
                  aCarry.add( fFields[i].value )
               endif
            endif // form.rowset.fields ...
        next

        // append a new record
        rRowToActOn.beginAppend()
            
        // -------------------------------
        // copy data from previous record:
        for i = 1 to fFields.size
            if aCarry[i] == "* Skip This Field *"
               loop
            else
               fFields[i].value := aCarry[i]
            endif  // skip ...
        next

        // redisplay
        rRowToActOn.refreshControls()

        // let user know:
        msgbox( ROWISCOPIED,;
                COPYCOMPLETE, 64 )
     endif
   return
endclass
/* ---------------------------------------------------- */
   
/* ---------------------------------------------------- */
class kmEditButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap := "RESOURCE:2 PS_EDIT"
   this.SpeedTip := EDITTIP

   function onClick
     local rRowToActOn, nState, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( EDITNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to modify a row ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTEDITROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTEDITROW, 16 )
                return
        endcase
        // Added November, 2004 -- if in a networked
        // environment, we may run into issues with
        // users attempting to edit the same row ...
        // This should resolve that -- I hope.
        // Attempt to lock row:
        if rRowToActOn.lockRow()
           rRowToActOn.beginEdit()
        else
           /*
              November 19 -- Modified this so that *if*
              the session for the rowset has the lockRetryCount
              set to a value > 0, we use the message below,
              otherwise we fall into the default message
              generated by dBASE.

              If I could guarantee that all users would
              set the session's lockRetryCount to 1 (or greater) for
              all rowsets, this wouldn't be an issue, but
              I cannot. Various attempts have been made
              by various developers for this, and it
              appears that you have to deactivate the
              query when you do this, set the lockRetryCount,
              and then reactivate the query. This means
              that you can't do it in a meaningful
              way in a custom class.
           */
           if rRowToActOn.parent.database.session.lockRetryCount > 0
              msgbox( ROWLOCKED,;
                      CANTEDITROW, 16 )
           endif
           return
        endif
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmSaveButton( parentObj ) of BaseSpeedButton( parentObj ) custom
   this.upBitmap := "RESOURCE:2 PS_SAVE"
   this.speedTip := SAVETIP

   function onClick
     local rRowToActOn, nState, nAnswer, cError
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( SAVENOROWSET,;
                CANTDOIT, 16 )
        return
     else
        nState = rRowToActOn.state
        do case
           case nState == 4
                msgbox( INFILTERMODE,;
                        CANTSAVEROW, 16 )
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTSAVEROW, 16 )
           case nState < 2 or nState > 3
                msgbox( NOTEDITING, NOCHANGES, 16 )
           otherwise
                // The following added by Tom Gleaton, avoids
                // problems when attempting to save a duplicate key:
                try
                   // Try it -- if no error is thrown, we're ok
                   rRowToActOn.save()
                   // added, November, 2004: if the
                   // row was locked by the kmEditButton,
                   // we need to unlock it. If it wasn't,
                   // there shouldn't be any adverse behavior
                   // caused by the unLock>
                   rRowToActOn.unlock()
                catch (Exception E)
                   // oops -- abandon save, refresh the rowState object
                   rRowToActOn.abandon()
                   // added, November, 2004: if the
                   // row was locked by the kmEditButton,
                   // we need to unlock it. If it wasn't,
                   // there shouldn't be any adverse behavior
                   // caused by the unLock>
                   rRowToActOn.unlock()
                   // deal with error returned:
                   if dbError() == "9729"
                      cError = KEYVIOLATION
                   else
                      cError = UNKNOWNERROR+dbError()
                   endif
                   // display it for user:
                   msgbox( cError, CANTSAVEROW, 16 )
                endtry
        endcase
        // for some reason, ONLY the save button
        // does not update the rowState ...
        form.rowset.refreshControls()
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmDeleteButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap := "RESOURCE:2 PS_DELETE"
   this.SpeedTip := DELETETIP

   function onClick
     local rRowToActOn, nState, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( DELETENOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to delete a row
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4
                msgbox( INFILTERMODE,;
                        CANTDELETEROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTDELETEROW, 16 )
                return
        endcase
        // actually delete it
        if not rRowToActOn.endOfSet
           if ( msgbox(DELETEYESNO, ;
                       ALERT, 4) == 6 )
              rRowToActOn.delete()
              // move to previous row, unless we're at
              // the first one, and then step off
              // the endOfSet marker ...
              if ( not rRowToActOn.next(-1) )
                 rRowToActOn.next()
              endif
           endif
        else
           msgbox( NOTHINGTODELETE,EMPTYTABLETEXT, 16 )
        endif
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmAbandonButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap := "RESOURCE:2 PS_ABANDON"
   this.SpeedTip := ABANDONTIP

   function onClick
     local rRowToActOn, nState
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( ABANDONNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        nState = rRowToActOn.state
        do case
           case nState == 4
                if msgbox( ABANDONWILLCANCELFILTER,;
                           CANCELFILTER, 33 ) == 2
                   return
                endif
           case nState == 5 // locate
                if msgbox( ABANDONWILLCANCELLOCATE,;
                          CANCELLOCATE, 33 ) == 2
                   return
                endif
           case nState < 2 or nState > 3
                msgbox( NOTHINGTOABANDON, CANTABANDONROW, 16 )
                return
        endcase
        rRowToActOn.abandon()
        // added, November, 2004: if the
        // row was locked by the kmEditButton,
        // we need to unlock it. If it wasn't,
        // there shouldn't be any adverse behavior
        // caused by the unLock>
        rRowToActOn.unlock()
     endif
endclass
/* ---------------------------------------------------- */

/*
   =====================================================
   FILTER and LOCATE buttons
   =====================================================
*/

/* ---------------------------------------------------- */
class kmFilterButton( parentObj ) of BaseSpeedButton( parentObj ) custom
/*
    Code by Santo Lo Galbo, in Italy
    This code was added 11/20/1998 -- it is designed
    to handle filter-by-form mode, and does it pretty
    durn well ...

    Minor modification added by Ronnie MacGregor, 
      October, 20, 1999, to deal with the rowset's
      clearFilter() method possibly being called elsewhere
      in the form ... it adds an 'else' clause to
      the main IF xx.rowstate==4 ...
      * In addition, Ronnie's suggested image for the 
        clearFilter state of the button makes more sense
        than the one currently in use ... (suggested to
        use RESOURCE #2240, which is the eraser on a pencil,
        rather than RESOURCE #2020, which is a lightbulb)

    If the image is "Filter", then we save the current
    bookMark (in case we need it), and we set the form
    to a filter-by-form mode. (We change the button image
    to 'run')

    If the image is "Run", we call applyFilter. If no
    match is found we go back to the bookMark saved
    above (if possible -- otherwise we go to the first
    row in the table). This includes turning off the
    notifyControls while the filter kicks in and
    tries to find the row. We turn it back on and update
    the form. If we found a match, we set the button
    to "clearFilter". If we did not find a match, we
    set it back to 'filter'

    If the button image is "clearFilter" we issue
    a call to clearFilter() and reset the image back
    to filter.

    A right-click on the button will reset the
    rowset's state back to browse (abandoning 
    the filter) and the button's image ...

    Very smooth and nicely designed code, this is
    an *excellent* example of morphing an object ...

    Side effects: adds property to the form:
     form.bookMark

   July, 2004: 
     Added code to change all hard-coded references
     to images to properties of the pushbutton, which
     allows a user to make changes in one place, rather
     than modifying the code itself. 
*/
   // set custom/default properties for
   // bitmap images:
   this.FilterBitmap   = "RESOURCE:2 PS_FILTER"
   this.RunBitmap      = "RESOURCE:2 PS_RUN"
   this.ClearBitmap    = "RESOURCE #2240"

   // Assign bitmap and speedtip:
   this.UpBitMap       := this.FilterBitmap
   this.SpeedTip       := FILTERTIP

   function onClick
     local rRowToActOn, nState, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( FILTERNOROWSET,;
                CANTDOIT, 16 )
        return
     else
         // if so, check the rowset state -- if we
         // are editing/adding a row, we don't want 
         // allow navigation or filering or ...
         nState = rRowToActOn.state
         do case
            case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
            case nState == 5 // locate
                 msgbox( INLOCATEMODE,;
                         CANTSETFILTER, 16 )
                 return
         endcase

         do case
            // we are in "beginFilter" mode:
            case this.upBitMap == this.FilterBitmap
                 // change bitmap to "Run"
                 this.upBitMap := this.RunBitmap
                 // save current bookMark so we can return 
                 // to it:
                 form.bookMark = rRowToActOn.bookMark()
                 // set form to "filter" mode
                 rRowToActOn.beginFilter()
            
            // we are in "Run" mode (applyFilter() )
            case this.upBitMap == this.RunBitmap
                 // don't update the controls until told otherwise
                 rRowToActOn.notifyControls := false
                 // try the filter -- if we don't find a match
                 // we'll clear it out ...
                 try // catch error about memo:
                    // IF statement added by Ronnie MacGregor:
                    if rRowToActOn.state == 4 // Check that the rowset is in Filter mode
                       if not rRowToActOn.applyFilter()
                          // reset the image back to the filter image
                          this.upBitMap := this.FilterBitmap
                          // clear the filter
                          rRowToActOn.clearFilter()
                          try
                             // attempt to go back to the 'bookMark'
                             // if we can't, we go to the first row
                             // in the table
                             rRowToActOn.goto( form.bookMark )
                          catch ( exception e )
                             rRowToActOn.first()
                          endtry
                          // let the user know that no match was found
                          msgbox( NOMATCH, FILTERTEXT, 48 )
                       else
                          // otherwise the filter worked, 
                          // so now we want to change the image to
                          // a "clear Filter" ...
                          this.upBitMap := this.ClearBitmap
                       endif // not rRowToActOn.applyFilter()
                    // this is the rest of the code added by Ronnie MacGregor:
                    else 
                       // the clearFilter() method has been called,
                       // or the filter property has been cleared out ...
                       msgbox( CANTSETFILTER, CANTDOIT, 48 )
                       rRowToActOn.goto( form.bookmark )
                       this.upBitMap := this.FilterBitmap
                    endif // end of code added by Ronnie
                 catch ( dbexception e )
                    msgbox( CANTFILTERINMEMO, FILTERTEXT, 48 )
                    rRowToActOn.goto( form.bookmark )
                    this.upBitMap := this.FilterBitmap
                 endtry

                 // turn this back on
                 rRowToActOn.notifyControls := true
                 // and actually refresh to show the first row
                 // that matches the filter
                 rRowToActOn.refreshControls()
               
            // clearFilter()
            case this.upBitMap == this.ClearBitmap
                 // reset image to filter
                 this.upBitMap := this.FilterBitmap
                 // clear out the current filter ...
                 rRowToActOn.clearFilter()
         endcase
      endif

   // this routine resets the button and
   // abandons the locate ...
   function onRightMouseDown // reset
     local rRowToActOn

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif form.rowset # null
        rRowToActOn = form.rowset
     endif

     if not this.upBitmap == this.FilterBitmap
        rRowToActOn.abandon()
        rRowToActOn.clearFilter()
        this.upBitmap := this.FilterBitmap
     endif

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmLocateButton( parentObj ) of BaseSpeedButton( parentObj ) custom
/*
    Santo Lo Galbo came through with some more code,
    this time to give a locate by form button.

    This one works similar to the kmFilterButton above,
    except that it does a locate-by-form.

    If the image is the PS_LOCATE image when the
    button is clicked, and we pass the checks
    to see what the rowset's state is, we
    change the image to PS_RUN, and then call
    the rowset's applyLocate -- this puts the form
    into locate-by-form mode.

    If the image is PS_RUN, we check to see if
    any changes were made in the form, and if not,
    we abandon the locate. Otherwise, we attempt
    to find something. If we can, we save the
    current bookmark, set the image to "locate again", 
    and let the user go for it again. 

    If the image is the "Locate again" image,
    we do another search unless we hit the endOfSet ...

    Very good example of morphing.

    Santo added an onRightMouseDown event call,
    which abandons (if necessary) and resets the
    image for the button ... rather handy to 
    simply reset this, and similar code has been
    copied above to the kmFilterButton as well.
    
    Side effects: adds property to the form:
     form.bookMark

   July, 2004: 
     Added code to change all hard-coded references
     to images to properties of the pushbutton, which
     allows a user to make changes in one place, rather
     than modifying the code itself. 
*/

   // set custom/default properties for
   // bitmap images:
   this.LocateBitmap      = "RESOURCE:2 PS_LOCATE"
   this.LocateAgainBitmap = "RESOURCE #860"
   this.RunBitmap         = "RESOURCE:2 PS_RUN"
   this.ClearBitmap       = "RESOURCE #2240"

   // Set bitmap and speedTip:
   this.UpBitMap       := "RESOURCE:2 PS_LOCATE"
   this.SpeedTip       := LOCATETIP

   function onClick
   /*
      Code below is by Santo Lo Galbo. This is similar to
      the kmFilterButton, except that it works with the
      locate-by-form abilities of the rowset ...
   */
     // first check to see if we're doing something
     // we shouldn't be when we attempt to set the filter:
     local rRowToActOn, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( LOCATENOROWSET,;
                CANTDOIT, 16 )
        return
     else

        do case
           case rRowToActOn.state == 2 or ;
                rRowToActOn.state == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
                return
           case rRowToActOn.state == 4
                msgbox( EXITFROMFILTER, ;
                        CANTSEARCH, 16 )
                return
        endcase

        // here's where all the work starts:
        do case
           // we're now in "locate by form" mode:
           case this.UpBitMap == this.LocateBitmap
                this.upBitmap := this.RunBitmap
                form.bookmark = rRowToActOn.bookmark()
                rRowToActOn.beginLocate()

           // we're in "Run" mode ...
           case this.upBitmap == this.RunBitmap
                // if user hit 'run' but didn't
                // change anything on the form:
                if not rRowToActOn.modified
                   this.upBitmap := this.LocateBitmap
                   rRowToActOn.abandon()
                   return
                endif

                // problem with doing a locate on
                // memo fields:
                try // the first 'try'
                   // here's the search:
                   rRowToActOn.notifyControls := false
                   if not rRowToActOn.applyLocate()
                      this.upBitmap := this.LocateBitmap
                      try // second/nested try
                         rRowToActOn.goto( form.bookMark )
                      catch ( exception e )
                         rRowToActOn.first()
                      endtry
                      msgbox( NOMATCH, SEARCH, 48 )
                   else
                      // we found a match ...
                      // search again image:
                      this.upBitmap := this.LocateAgainBitmap
                      // save *this* bookmark ...
                      form.bookmark = rRowToActOn.bookmark()
                   endif
                catch ( exception e )
                   msgbox( CANTSEARCHINMEMO, SEARCH, 48 )
                   rRowToActOn.goto( form.bookmark )
                   this.upBitMap := this.LocateBitmap
                endtry // end of catch for memo

                rRowToActOn.notifyControls := true
                rRowToActOn.refreshControls()

           // we're "searching again"
           case this.upBitmap == this.LocateAgainBitmap
                // look for the next match:
                if not rRowToActOn.locateNext()
                   rRowToActOn.goto( form.bookmark )
                   msgbox( NOMOREMATCHES, SEARCH, 48 )
                   this.upBitmap := this.LocateBitmap
                else
                   form.bookmark = rRowToActOn.bookmark()
                endif
        endcase

     endif

   // this routine resets the button and
   // abandons the locate ...
   function onRightMouseDown // reset
     local rRowToActOn

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     if not this.upBitmap = this.LocateBitmap
        rRowToActOn.abandon()
        this.upBitmap := this.LocateBitmap
     endif

endclass
/* ---------------------------------------------------- */

/* =======================================================
   Clipboard Buttons:
   ======================================================= */

/* ---------------------------------------------------- */
class kmCutButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #2030"
   this.DisabledBitMap := "RESOURCE #2031"
   this.SpeedTip       := CUTTIP

   function onClick
       if type("this.form.activeControl.cut") == "FP"
          this.form.activeControl.cut()
       endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmCopyButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #2040"
   this.DisabledBitMap := "RESOURCE #2041"
   this.SpeedTip       := COPYTIP

   function onClick
       if type("this.form.activeControl.copy") == "FP"
          this.form.activeControl.copy()
       endif

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmPasteButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #2050"
   this.DisabledBitMap := "RESOURCE #2051"
   this.SpeedTip       := PASTETTIP

   function onClick
       if type("this.form.activeControl.paste") == "FP"
          this.form.activeControl.paste()
       endif

endclass
/* ---------------------------------------------------- */


/* =======================================================
   Misc. Buttons:
   ======================================================= */

/* ---------------------------------------------------- */
class kmCloseButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #1005"
   this.DisabledBitMap := "RESOURCE #1006"
   this.SpeedTip       := CLOSETIP

   function onClick
     local rRowToActOn, nState, nAnswer
     rRowToActOn = null

     // check to see if rowset property has been set:
     rRowToActOn = super::GetRowset()

     // is there a valid rowset?
     if rRowToActOn # null
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to just close the form ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4
                msgbox( INFILTERMODE,;
                        CANTABANDONROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTABANDONROW, 16 )
                return
        endcase
     endif
     form.close()
endclass
/* ---------------------------------------------------- */


/* =======================================================
   Buttons with no onClick event set ... you will need to
   create the code in your form ... (and you may want to
   override the speedTip property, too ...)
   ======================================================= */

/* ---------------------------------------------------- */
class kmYesButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #36"
   this.DisabledBitMap := "RESOURCE #37"
   this.SpeedTip       := YESTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmNoButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #24"
   this.DisabledBitMap := "RESOURCE #25"
   this.SpeedTip       := NOTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmCancelButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #28"
   this.DisabledBitMap := "RESOURCE #29"
   this.SpeedTip       := CANCELTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmQuestionButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #32"
   this.DisabledBitMap := "RESOURCE #33"
   this.SpeedTip       := QUESTIONTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmLightningButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE:2 PS_RUN"
   this.SpeedTip       := RUNTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmInfoButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #112"
   this.SpeedTip       := INFOTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmFromDiskButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #1410"
   this.DisabledBitMap := "RESOURCE #1420"
   this.SpeedTip       := RESTOREFROMDISKTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmToDiskButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #1430"
   this.DisabledBitMap := "RESOURCE #1440"
   this.SpeedTip       := SAVETODISKTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmOpenFolderButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE:2 PS_OPEN"
   this.SpeedTip       := OPENFILETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmWrenchButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #144"
   this.SpeedTip       := TOOLBUTTONTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmPrintButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #857"
   this.DisabledBitMap := "RESOURCE #867"
   this.SpeedTip       := PRINTTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmSearchButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #858"
   this.DisabledBitMap := "RESOURCE #868"
   this.SpeedTip       := SEARCHTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmSearchAgainButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #860"
   this.DisabledBitMap := "RESOURCE #870"
   this.SpeedTip       := SEARCHAGAINTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmReplaceButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #859"
   this.DisabledBitMap := "RESOURCE #869"
   this.SpeedTip       := REPLACETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmSearchButton2( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE:2 PS_LOCATE"
   this.SpeedTip       := SEARCHTIP

endclass
/* ---------------------------------------------------- */


/* ---------------------------------------------------- */
class kmExitButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #1005"
   this.DisabledBitMap := "RESOURCE #1006"
   this.SpeedTip       := EXITTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmFirstPageButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE:2 PS_RFIRST"
   this.SpeedTip       := FIRSTPAGETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmNextPageButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE:2 PS_RNEXT"
   this.SpeedTip       := NEXTPAGETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmPreviousPageButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE:2 PS_RPREV"
   this.SpeedTip       := PREVIOUSPAGETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmLightBulbButton( parentObj ) of BaseSpeedButton( parentObj ) custom

   this.UpBitMap       := "RESOURCE #2020"
   this.DisabledBitMap := "RESOURCE #2021"
   this.SpeedTip       := LIGHTBULBTIP

endclass
/* ---------------------------------------------------- */


/*
   =============================================================
   RowState Control
   Designed to show status of current row ...
   =============================================================
*/
class kmRowState(parentObj, name) of ENTRYFIELD(parentObj, name) custom
/*
   Programmer: Gary White
   Some modifications by Ken Mayer as noted below

	This RowState object displays the current state of a rowset.  
   Unlike the original one shipped with VdB, this one uses an 
   entryfield, datalinked to a calculated field.  This eliminates 
   the necessity of manually refreshing it.  This was a large 
   task in the original, since it traversed all the objects on 
   the form to see if any of them were rowset objects.  On a 
   large form, this could be rather slow.  With this one, the 
   calc field handles the update automatically.

	This should function just fine with any existing code using 
   the original unless you manually manipulated the text 
   property of the original version. You don't need to force 
   a refresh in any of your functions.

   // Minor property modifications:
   colorNormal := "Maroon/BtnFace"
   fontSize    := 10

   // Additional code by Ken Mayer
   initRowset method was added -- the reasoning is:
      In some of my forms, I do a parent/child relationship,
      and switch rows based on which table has focus by
      setting the form's rowset property. It is absurd
      to have to do a bunch of extra work to get the rowState
      class here to keep up. This method will make sure that
      if the calculated field does not exit, it gets created
      (calling this object's onOpen event), and then it
      makes sure the dataLink is correct. It works in the 
      testing I've done, pretty well ...

   To use this effectively, there are two ways.

   If you are using "KensToolbar" on a form, you would
   change your form's rowset property and call this method
   as:  form.rowset := newRowsetReference
        form.kensToolbar1.rowState.initRowset()

   If you are *not* using the toolbar, and you have an
   instance of the rowstate object directly on the form:
        form.kmRowState1.initRowset()

*/

	// hide some properties that aren't appropriate and our methods
	protect datalink, function, maxLength, memoEditor, phoneticLink, ;
      picture, selectAll, validErrorMsg, validRequired, tabStop, ;
      key, onChange, valid, enabled, helpFile, helpId, ;
      mousePointer, statusMessage, tabStop, colorHighLight, ;
      onOpen, onGotFocus

   with (this)
      onOpen = class::rowState_onOpen
      when         := {;return false}           // we don't want focus
      onGotFocus   := {;this.keyboard("{Tab}")} // just in case
      height       := 0.8182
      left         := 11.7143
      top          := 0.6818
      width        := 9.4286
      metric       := 0  // Chars
      colorNormal  := "Maroon/BtnFace" // color preference by KM
      fontSize     := 10
      fontBold     := true
      fontItalic   := true
      value        := "RowState"
      mousePointer := 1	// Arrow
      borderStyle  := 1	// Raised
   endwith

   this.rowset = null

   // Added by Ken:
   function initRowset 
      // The idea is if you are using a second (or more)
      // rowset on the form, but one set of buttons
      // to manipulate any/all rowsets, you need
      // to make sure that the "current" rowset
      // has the calc field necessary to update
      // this control:
      local rRowToActOn
      rRowToActOn = null

      // check to see if rowset property has been set:
      rRowToActOn = BaseSpeedButton::GetRowset()

      this.rowsetDisplayed = rRowToActOn
      // check for calc field, if it already exists,
      // there's nothing to do except ensure the
      // datalink:
      if type('this.rowsetDisplayed.fields["gwRowstate"]') == "O"
         this.dataLink = this.rowsetDisplayed.fields["gwRowstate"]
      else
         class::rowState_onOpen()
      endif

   function rowState_onOpen
      private rRowToActOn
      rRowToActOn = null

      // check to see if rowset property has been set:
      rRowToActOn = BaseSpeedButton::GetRowset()

      if type("rRowToActOn") == "O"	// if we have a rowset
      	// allow the rowset to be something other than the 
         // form.rowset if you want to display another rowset, 
         // just set rowstate.rowset = rowsetToDisplay
         // in the form's onOpen event.

         // if we haven't already defined the calc field
         if type('rRowToActOn.fields["gwRowstate"]') # "O"
         	// do it here
            local f
            f = new field()		  // create it
            f.states = new array() // build an array with the 
                                   // possible states
            f.states.add(STATECLOSED)
            f.states.add(STATEVIEW)   // Gary's says "Browse"
            f.states.add(STATEEDIT)
            f.states.add(STATEAPPEND)
            f.states.add(STATEFILTER)
            f.states.add(STATELOCATE)
            f.fieldName      := "gwRowstate"
            f.beforegetvalue := ;
               {;return this.states[ this.parent.parent.state + 1 ]}
            rRowToActOn.fields.add( f )
         endif
         this.datalink = rRowToActOn.fields["gwRowstate"]
      endif
   return
endclass

/*
   =======================================================
   End of Custom Class file: CUSTBUTT.CC
   ======================================================= 
*/

