************************************************************************
*                                                                      *
*       VdB-Logic                                                      * 
*       FontSetter                                                     *
*       Programmer :  2005 - Marc Van den Berghen                      *
*       Version 0.1                                                    *
*       Make sure, that a special font is available immediately        *
*       No need to place the font in the system directory.             *
*       On WIN2000/XP you can restrict the use of the font to your     *
*       application.                                                   *   
*                                                                      *
*       Usage :  set procedure to font_setter.cc additive              *
*                fs = new fontsetter                                   *
*                fs.font.add("AC.ttf")                                 *
*                fs.font.add( <yet another font>)                      *
*                fs.public = false // default true works only on 2K/XP *
*                fs.register()                                         *
*                fs.free() // cleanup                                  *
************************************************************************

// File  font_setter.cc

#define FR_PRIVATE   0x10

Class Fontsetter of Object
   extern culong GetVersion(cvoid) kernel32
   this.ver   = ( bitand(getversion(),255) > 4 )
   if this.ver 
      extern culong FontSet(cstring,culong,cptr) gdi32 ;
             from "AddFontResourceExA" 
      extern clogical FontFree(cstring,culong,cptr) gdi32 ;
             from "RemoveFontResourceExA"
   else
      extern culong FontSet(cstring) gdi32 ;
             from "AddFontResourceA" 
      extern clogical FontFree(cstring) gdi32 ;
             from "RemoveFontResourceA"
   endif
   this.font    = new array()   // Array of font-file-paths
   this.public = true

   Function register()   // make the font(s) available immediatly
      local ntmp,i
      ntmp = iif(this.public,0,FR_PRIVATE)
      for i = 1 to this.font.size
         if this.ver
            fontset(this.font[i],ntmp,null)
         else
            fontset(this.font[i])
         endif
      endfor
   return         

   Function free()   // unregister the fonts and clean up
      local ntmp,i
      ntmp = iif(this.public,0,FR_PRIVATE)
      for i = 1 to this.font.size
         if this.ver
            fontfree(this.font[i],ntmp,null)
         else
            fontfree(this.font[i])
         endif
      endfor
      release object this
   return         
endclass

// End of file font_setter.cc