/*
    -----------------------------------------------------------
    custbuttNorwegian.h
    February 11, 1999
    Ken Mayer
    Norwegian Translation of "custButtEnglish.h" 
       by Morten Novum

     *** Note: you should copy this file to your
     ..\Visual dBASE\INCLUDE directory for it to
     be used properly by all of your applications.

    This is an 'include' file with the speedTips and
    message box text for each of the buttons in CUSTBUTT.CC.
    The idea is that by defining them here, someone using
    another language can copy this file and translate the
    text in the .H file, and the only change necessary in
    CUSTBUTT.CC is the #INCLUDE statement to include
    the correct file.

    When translating, make sure you do NOT change the names
    of the constants ...

    *****************
    November 11, 2000
    *****************
    NOTE: If you update your application to use the 
    CUSTBUTT.CC file from dUFLP version 2KC (DUFLP2KC.EXE),
    then you MUST update your .H file -- this is a fix based
    on a discovery that EMPTYTABLE and FILTER strings could
    cause problem in code that used the database object
    emptyTable method, or the rowset object's filter property.
    These strings are defined as EMPTYTABLETEXT and FILTERTEXT
    now, and will not cause a conflict.

    Suggestion by Francesco Navarria, in Italy ...
    **********************************************************
    *** WARNING: If you are not using an ANSI language driver
    *** for your tables (at the Command window: ? LDRIVER()
    *** it should be obvkous) or have the setting:
    ***  LDRIVER=WINDOWS in your VDB.INI file (under the
    *** [CommandSettings] heading) do NOT attempt save
    *** this file ... you can wipe out the upper ANSI characters
    *** used. 
    **********************************************************
    -----------------------------------------------------------
*/

// ----------------------------------------------------------
// navigation buttons:
                                //"First row in rowset"
#define TOPTIP                  "Frste rad i radsettet"
                                //"Previous row in rowset"
#define PREVTIP                 "Forrige rad i radsettet"
                                 //"Next row in rowset"
#define NEXTTIP                 "Neste rad i radsettet"
                                //"Last row in rowset"
#define ENDTIP                  "Siste rad i radsettet"

// ----------------------------------------------------------
// editing buttons:
                                //"Add new row"
#define ADDTIP                  "Legg til ny rad"
                                //"Copy data to a new Row"
#define CARRYTIP                "Kopier data til ny rad"
                                //"Edit current row"
#define EDITTIP                 "Endre denne raden"
                                //"Save current row"
#define SAVETIP                 "Lagre denne raden"
                                //"Delete current row"
#define DELETETIP               "Slette denne raden"
                                //"Abandon changes to row"
#define ABANDONTIP              "Avbryt endringer i raden"

// ----------------------------------------------------------
// filter/locate buttons:
                                //"Filter/Run/Clear Filter"
#define FILTERTIP               "Filtrer/Kjr/Slett Filter"
                                //"Locate/Run/Clear Locate"
#define LOCATETIP               "Lokaliser/Kjr/Slett Lokaliser"

// ----------------------------------------------------------
// clipboard buttons:
                                //"Cut selected text"
#define CUTTIP                  "Slett merket tekst"
                                //"Copy selected text"
#define COPYTIP                 "Kopier merket tekst"
                                //"Paste from clipboard"
#define PASTETTIP               "Lim inn fra klippebordet"

// ----------------------------------------------------------
// misc. buttons:
                                //"Close this form"
#define CLOSETIP                "Lukker dette vinduet"
                                //"Yes"
#define YESTIP                  "Ja"
                                //"No"
#define NOTIP                   "Nei"
                                //"Cancel"
#define CANCELTIP               "Avbryt"
                                //"Question? Help?"
#define QUESTIONTIP             "Sprsml? Hjelp?"
                                //"Run"
#define RUNTIP                  "Kjr"
                                //"Information"
#define INFOTIP                 "Informasjon"
                                //"Restore from disk"
#define RESTOREFROMDISKTIP      "Gjenopprett fra disk"
                                //"Save to disk"
#define SAVETODISKTIP           "Lagre til disk"
                                //"Open file ..."
#define OPENFILETIP             "pne fil ..."
                                //"Tool Button"
#define TOOLBUTTONTIP           "Verktyknapp"
                                //"Print"
#define PRINTTIP                "Skriv"
                                //"Search"
#define SEARCHTIP               "Sk"
                                //"Continue search"
#define SEARCHAGAINTIP          "Fortsett sket"
                                //"Replace"
#define REPLACETIP              "Erstatt"
                               //"Exit"
#define EXITTIP                 "Avslutt"
                                //"First Page"
#define FIRSTPAGETIP            "Frste side"
                                //"Next Page"
#define NEXTPAGETIP             "Neste side"
                                //"Previous Page"
#define PREVIOUSPAGETIP         "Forrige side"
                                //"The Light Goes Off"
#define LIGHTBULBTIP            "Slr av lyset"


// ----------------------------------------------------------
// strings used in dialog boxes in CUSTBUTT.CC
// ----------------------------------------------------------

// This one appears as the title for various dialogs
                                //"Can't do it!"
#define CANTDOIT                "Kan ikke utfre dette!"

// ----------------------------------------------------------
// One of these appears anytime we check to see if the rowset
// is null, and is the text in the messagebox
                                //"Cannot Navigate with no rowset!"
#define NAVNOROWSET             "Kan ikke navigere uten radsett!"
                                //"Cannot add rows with no rowset!"
#define ADDNOROWSET             "Kan ikke legge til rader uten radsett!"
                                //"Cannot copy rows on a form without a rowset!"
#define COPYNOROWSET            "Kan ikke kopiere rader uten radsett!"
                                //"Cannot update rows on a form without a rowset!"
#define EDITNOROWSET            "Kan ikke oppdatere rader uten radsett!"
                                //"Cannot save changes to rows on a form without a rowset!"
#define SAVENOROWSET            "Kan ikke lagre endringer i skjemaet uten radsett!"
                                //"Cannot save delete rows on a form without a rowset!"
#define DELETENOROWSET          "Kan ikke lagre slettede rader i skjemaet uten radsett!"
                                //"Cannot abandon changes to rows on a form without a rowset!"
#define ABANDONNOROWSET         "Kan ikke avbryte endringer i rader p skjemaet uten radsett!"
                                //"Cannot filter an empty or missing rowset!"
#define FILTERNOROWSET          "Kan ikke filtrere et tomt eller manglende radsett!"
                                //"Cannot perform a locate with no rowset!"
#define LOCATENOROWSET          "Kan ikke utfre lokaliser uten radsett!"

// ----------------------------------------------------------
// this is the title and message when the user attempts
// to navigate or close a form and the data has
// changed ...
                                //"Data has changed"
#define DATACHANGED             "Data er endret"
                                //"Save changes before leaving record?"
#define SAVECHANGES             "Lagre endringer fr raden forlates?"

// ----------------------------------------------------------
// Title when user can't navigate:
                                //"Can't Navigate!"
#define CANTNAVIGATE            "Kan ikke navigere!"

// ----------------------------------------------------------
// Other messages ...
                                //"You are in filter mode"
#define INFILTERMODE            "Du er i  filter modus"
                                //"You are in locate mode"
#define INLOCATEMODE            "Du er i lokaliserings modus"
                                //"At first row in rowset"
#define ATFIRSTROW              "P frste rad i radsettet"
                                //"At last row in rowset"
#define ATLASTROW               "P siste rad i radsettet"
                                //"Row is copied -- you are in append mode. Make changes and save or abandon new row."
#define ROWISCOPIED             "Raden er kopiert -- du er i legg til modus.  Utfr endringer og lagre eller avbryt ny rad."

#define ROWLOCKED               "Row is being edited by another. Try again later."
                                //"Cannot Save edits/new row when you weren't editing/adding"
#define NOTEDITING              "Kan ikke lagre endringer/ny rad nr du ikke har endret/lagt til"
                                //"Key Violation - That Key already exists."
#define KEYVIOLATION            "Nkkel feil - Denne nkkelen eksisterer allerede."
                                //"Unknown error -- "
#define UNKNOWNERROR            "Ukjent feil -- "
                                //"You are about to delete the current row." + CHR(13) + "Click Yes to delete the current row."
#define DELETEYESNO             "Du slettet gjeldende rad." + CHR(13) + "Klikk Ja for  slette gjeldende rad."
                                //"Nothing to delete!"
#define NOTHINGTODELETE         "Ingenting  slette!"
                                //"Abandoning the row will cancel the filter!"
#define ABANDONWILLCANCELFILTER "Avbryte raden vil oppheve filter modus!"
                                //"Abandoning the row will cancel the locate!"
#define ABANDONWILLCANCELLOCATE "Avbryte raden vil oppheve lokaliser modus!"
                                //"Cannot Abandon edits/new row when you weren't editing/adding!"
#define NOTHINGTOABANDON        "Kan ikke avbryte endring/ny rad nr du ikke har endret/lagt til!"
                                //"No Match"
#define NOMATCH                 "Finnes ikke"
                                //"Exit from filter mode!"
#define EXITFROMFILTER          "G ut av filter modus!"
                                //"No more matches!"
#define NOMOREMATCHES           "Ingen flere treff!"
                                //"Can't search in memo field!"
#Define CANTSEARCHINMEMO	     "Kan ikke ske i memo felt!"
                                //"Can't filter on a memo field!"
#define CANTFILTERINMEMO	     "Kan ikke opprette filter p memo felt!"

// ------------------------------------------------------------
// Misc Titles
                                //"Can't Add a new row!"
#define CANTADDROW              "Kan ikke legge til rad!"
                                //"Can't Copy row!"
#define CANTCOPYROW             "Kan ikke kopiere rad!"
                                //"Copy complete"
#define COPYCOMPLETE            "Kopiering ferdig"
                                //"Can't Edit row!"
#define CANTEDITROW             "Kan ikke endre rad!"
                                //"Can't Save row!"
#define CANTSAVEROW             "Kan ikke lagre rad!"
                                //"No changes to save!"
#define NOCHANGES               "Ingen endringer  lagre!"
                                //"Can't Delete row!"
#define CANTDELETEROW           "Kan ikke slette rad!"
                                //"Alert"
#define ALERT                   "Advarsel"
                                //"Empty table"
#define EMPTYTABLETEXT          "Tom tabell"
                                //"Cancel Filter?"
#define CANCELFILTER            "Avbryt filter?"
                                //"Cancel Locate?"
#define CANCELLOCATE            "Avbryt lokaliser?"
                                //"Can't abandon row!"
#define CANTABANDONROW          "Kan ikke avbryte rad!"
                                //"Can't set a filter!"
#define CANTSETFILTER           "Kan ikke opprette filter!"
                                //"Filter"
#define FILTERTEXT              "Filter"
                                //"Can't start a search!"
#define CANTSEARCH              "Kan ikke starte sk!"
                                //"Search"
#define SEARCH                  "Sk"

// -----------------------------------------------------------
// kmRowState -- states:
				                    //"Closed"
#define STATECLOSED             "Lukket"
                                // "View" // "Browse" == "Se p" 
#define STATEVIEW               "Vista" 
                                //"Edit"
#define STATEEDIT               "Endre"
                                //"Append"
#define STATEAPPEND             "Legg til"
                                //"Filter"
#define STATEFILTER             "Filter"
                                //"Locate"
#define STATELOCATE             "Lokaliser"


// -----------------------------------------------------------
// End of header file: custButtNorwegian.h
// -----------------------------------------------------------

