/*
   Maximum.prg
   Gary White
   July 20, 2001
   This is an enhanced version of the MAX() function
   in dBL. It will handle a list of parameters (rather
   than two which is what MAX() uses), or an array,
   and will return the largest value.

   Note that no error checking for types is made in this 
   function. 

   Examples:

      ? Maximum( 1, 5, -1, 6 ) // should return 6
      ? Maximum( { 1, 5, -1, 6 } ) // should return 6
      a = { 1, 5, -1, 6 } // literal array
      ? Maximum( a ) // should return 6
      a = new array()
      a.add( 1 )
      a.add( 5 )
      a.add( -1 )
      a.add( 6 )
      ? Maximum( a ) // should return 6
*/

function Maximum
   local bRet, i
   bRet = 2 ^ -256
   if type('argvector(1)') == 'A'
   	for i = 1 to argvector(1).size
? bRet, argvector(1)[i]
          bRet = max(bRet, argvector(1)[i])
      next
   else
   	for i = 1 to argCount()
          bRet = max(bRet, argVector(i))
      next
   endif
return bRet
// End of function: Maximum()

