
#DEFINE DUFLP      // uncomment for compilation for standalone DUFLP use
							// comment out for use within an EDM app

#IFDEF DUFLP 
	#DEFINE STOREPATH			"c:\temp"	  //Please give the folder for Default storage 
														//exported files.				
	#DEFINE PATHSINTABLE    false 
	#DEFINE logfile         "zeexportdata.log"		//name of logfile, add path
	#DEFINE logerrorfile    "zeexportdataerror.log" //name of logfile, add path
#ELSE
	#DEFINE STOREPATH			"c:\temp"	  //Please give the folder of your dot-Files.				
	#DEFINE BACKGROUNDART   "filename j:\edm\art\message_pole.jpg"
	#DEFINE logfile         "edmsilent.log"
	#DEFINE logerrorfile    "edmerror.log"
#ENDIF


#DEFINE ProgramVersion "1.0"



// zeexportdata.cc
// 20050105

/*
	This Custom Class encapsulates some Exports 
	that are to be performed by zeexportdata.wfm

	This functions mainly on basis of my structering of tables.

	I'm a bit lazy on documentation here, but compare the .wfm

	functions included:

		for immediate use:
			zeExportData(oQuery)
			zeExportDataHide(oQuery)
			zeExportDataClean(oQuery)

			zeExportDataDefault(oQuery)
			zeExportHtml4Mailmerge(oQuery,bSilent,cFileName)

		additional functions
			zeExportDataHideFrom(oQuery,cHide)
*/

function zeExportData(oQuery)
	// this opens the standard export form
	private ef,oQ
	oQ=oQuery
	set procedure to zeexportdata.wfm
	ef= new zeExportDataForm()
	ef.oQuery=oQ
	ef.nConversion = 0
	ef.bSilent=false
	ef.cFileName=" "
	ef.open()
	close procedure zeexportdata.wfm
	return

function zeExportDataHide(oQuery)
	// this opens the standard export form
	// but hides any fields behind "Invalidated"
		// usually no longer used fields are at the end of my tables
		// no harm done when not existing
	private ef,oQ
	oQ=oQuery
	set procedure to zeexportdata.wfm
	ef= new zeExportDataForm()
	oQ=zeExportDataHideFrom(oQ,"Invalidated")
	ef.oQuery=oQ
	ef.nConversion = 0
	ef.bSilent=false
	ef.cFileName=" "
	ef.open()
	close procedure zeexportdata.wfm
	return

function zeExportDataClean(oQuery,bSilent)
	// this opens the standard export form
	// hides all fields after "Aname" ,containing a reference to the user adding
		// usually fields organising data are here at the end of the table
		// no harm done when not existing
	private ef,oQ
	oQ=oQuery
	set procedure to zeexportdata.wfm additive
	ef= new zeExportDataForm()
	oQ=zeExportDataHideFrom(oQ,"Aname")
	ef.oQuery=oQ
	ef.nConversion = 0
	ef.bSilent=false
	ef.cFileName=" "
	ef.open()
	close procedure zeexportdata.wfm
	return

function zeExportDataDefault(oQuery)
	// this gives a silent export to a html-table named
	// according to the table name in use by the query
	// and stores in a local temporary path (where e.g. 
	// my docs look for there Mailmerge adressfile
	private oQ
	oQ=oQuery
	cTabnam=getfilenameonly(oQuery.rowset.tablename)
	#IFDEF DUFLP
		cFileName=STOREPATH+cTabnam+".htm"
	#ELSE
		cStorepath=_app.Ini["PathTemp"]
		cFileName=cStorepath+cTabnam+".htm"
	#ENDIF
	zeExportHtml4Mailmerge(oQ,true,cFileName)
	return


//****************************************


function zeExportDataHideFrom(oQ,cHide)
	private oQh
	oQh = oQ
	// subfunction for the hide-functions
	if type("oQh.zeNoExport")#"A"
		oQh.zeNoExport = new Array()
	endif
	local n,x,c
	//look for last systemfield
	n=oQh.rowset.fields.size
	for x = oQh.rowset.fields.size to 1 step -1
		if upper(oQh.rowset.fields[x].fieldname)=upper(cHide)
			n=x	
		endif
	next x
	// store to noex
	for x = n to oQh.rowset.fields.size
		oQh.zeNoExport.add(oQh.rowset.fields[x].fieldname)
	next x
	/* Alternative Code by reducing fieldlist
	// reduce fieldlist
	do while oQuery.rowset.fields.size > n
		x= oQuery.rowset.fields.size
		oQuery.rowset.fields.delete(x)
	enddo
	*/
	return oQh

// ----------------------------

function zeExportHtml4Mailmerge(oQuery,bSilent,cFileName)
	// this function does the actuall export for Default
	private oQ
	oQ=oQuery
	oQ=zeExportDataHideFrom(oQ,"Aname")
	set procedure to zeexportdata.wfm
	ef= new zeExportDataForm()
	ef.oQuery=oQ
	ef.bSilent=bSilent
	ef.nconversion=0
	ef.cFileName=cFileName
	ef.open()
	ef.notebook1.cursel=2
	// ZE when seting other defaults in form
	//	ef.notebook1.exporttype.html.value=true
	//	ef.notebook1.html.visible=true
	//	ef.notebook1.html.tableonly=true
	ef.selectallfieldsbutton_onClick()
	ef.OUTPUTFILEBUTTON_onClick(cFileName)
	ef.close()
	close procedure zeexportdata.wfm
	return


// ----------------------------------
/*
function zeExportPVWOLD(oQuery,cFilename)
	// this gives a silent and minimized export 
	// to a html-table for my old PVW tables
	// looked as I'd need conversion here...
	cStorepath=_app.Ini["PathTemp"]
	cFileName=cStorepath+cFilename+".htm"
	set procedure to zeexportdata.wfm
	ef= new zeExportDataForm()
	ef.oQuery=oQuery
	ef.bSilent=true
	ef.cFileName=cFileName
	ef.nConversion=0
	//ef.windowstate=1
	ef.open()
	ef.notebook1.cursel=2
	ef.selectallfieldsbutton_onClick()
	ef.OUTPUTFILEBUTTON_onClick(cFileName)
	ef.close()
	close procedure zeexportdata.wfm
	return
*/

//***************************************


function zeExportPVWOLD(oQuery,cFilename)

	// this gives a silent and minimized export 
	// to a html-table 
	#IFDEF DUFLP
		cFileName=STOREPATH+cTabnam+".htm"
	#ELSE
		cStorepath=_app.Ini["PathTemp"]
		cFileName=cStorepath+cTabnam+".htm"
	#ENDIF
	//set procedure to zeexportdata.wfm
	HTMLExport(oQuery,cFileName)
	return

function HTMLExport(oQ,cOutFile) 
	// This is a stripped completly noninteractive version for 
	// speedup of export to an html file
		
	// Output to an HTML File 
	private aInvalidFields, cOutString, aInvalid
	private r,f
		aInvalidFields = new array()

	// just a short list of field types that
	// cannot be output to HTML from a table
	aInvalid = new array()
	aInvalid.add( "BINARY" )
	aInvalid.add( "OLE" )
	aInvalid.add( "FMTMEMO" )
	aInvalid.add( "BYTES" )
	aInvalid.add( "GRAPHIC" )

	// create File object
	fOutFile = new file()
	fOutFile.Create( cOutFile, "W" ) // Write

	r=oQ.rowset
	r.first()
	f=r.fields
	// first we have to output the "stuff" at the beginning
	// of an HTML file. We're not going to do this really
	// fancy, but ... Some of this is based loosely on
		// code by David Kerber, in his ListTo.prg ...
	cOutString = '<!doctype html public "-//w3c//dtd html 4.0 transitional//en">'
	fOutFile.puts( cOutString )
	cOutString = "<HTML>"
	fOutFile.puts( cOutString )
	cOutString = "<HEAD>"
	fOutFile.puts( cOutString )
	cOutString = "<TITLE>Data from "+r.tableName+" </TITLE>"
	fOutFile.puts( cOutString )
	cOutString = "<! Generated by HTMLExport by Erich Zippel "
	fOutFile.puts( cOutString )
	fOutFile.puts( cOutString )
	cOutString = "   Date: "+date()+"                         -->"
	fOutFile.puts( cOutString )
	cOutString = "</HEAD>"
	fOutFile.puts( cOutString )
	cOutString = "<BODY>"
	fOutFile.puts( cOutString )

	// Now we want the beginning tags for the table that will
	// be used to display the data -- we're optionally
	// setting the border to 1, so we can see the 'grid',
	// based on the checkbox on the form for this option:
	cOutString = [<CENTER>] // center it on the HTML page
	fOutFile.puts( cOutString )
	cOutString = [<TABLE ]
	cOutString += [BORDER="1" ]
	cOutString += [CELLPADDING="2" CELLSPACING="0">]
	fOutFile.puts( cOutString )

	// first row must be the 'header' row, which is the 
	// names of the columns ...
	cOutString = "<TR>" // table row
	fOutFile.puts( cOutString )
	for i = 1 to r.fields.size
		 cFieldName = f[ i ].fieldname
//		 cType = f[ i ].type
//		 cFieldType = f[ cFieldName ].type
		 // if it's not in the invalid field type list
//		 if aInvalid.scan( cFieldType ) == 0
//		 if aInvalid.scan( cType ) == 0
			 cOutString = "<TH>"+cFieldName+"</TH>"
			 fOutFile.puts( cOutString )
//		 endif
	next
	cOutString = "</TR>" // end of table row
	fOutFile.puts( cOutString )

	// Loop through table:
	r.first()
	do while not r.endOfSet
		// Start a table row
		cOutString = [<TR VALIGN=TOP>]
		fOutFile.puts( cOutString )

		for i = 1 to r.fields.size
												// only one
			 cFieldName = f[ i ].fieldname
			 cType = f[ i ].type
			 // now we determine output based on type
			 do case
			 // Test for Invalid field types first:
//			 case aInvalid.scan( cType ) > 0

				// Then deal with null or empty fields:
				case f[ cFieldName ].value == null or;
						empty( f[ cFieldName ].value )
						// deal with null values first:
						if type( "f[ cFieldName ].value" ) == "N"
							cOutString = [<TD>]+"&nbsp;"+[</TD>]
						else
							cOutString = [<TD>]+"&nbsp;"+[</TD>]
						endif

				 // deal with the various numeric types:
				case type( "f[ cFieldName ].value" ) == "D" 
						cOutString = [<TD>]+dtoc(f[ cFieldName ].value)+[</TD>]						
				case type( "f[ cFieldName ].value" ) == "N" or;
						cType == "NUMERIC" // to handle calculated fields
						// right align:
						cOutString = [<TD ALIGN=RIGHT>]+;
							 ""+f[ cFieldName ].value+[</TD>]
					 
				case cType == "LOGICAL"
						// ZE 20050110 Added support for Options on boolean output
						cOutString = [<TD>]+iif(f[ cFieldName ].value,"J","N")+[</TD>]						
				otherwise
					cValue = ""+f[ cFieldName ].value
					cName = f[ cFieldName ].fieldname
					cOutString = [<TD>]+ltrim(trim(cValue))+[</TD>]
					if cType == "CHARACTER" or ;
						cType == "ALPHA" or ;
							cType == "MEMO"
						// if we have chr(13) in there:
						if at( chr(13), cOutString ) > 0
							// loop until we have changed all of them:
							do while ( at( chr(13), cOutString ) > 0 )
								// replace chr(13) with nothing:
								cOutString = stuff( cOutString, at( chr(13), cOutString ), 1, "" )
							enddo
						endif
						if cName = "NAMELVZ"
/*							zy=""
							zx=OEM(cOutString)
							for zn=1 to len(zx)
								zy+=asc(substr(zx,zn,1))
								zy+=","
							next zn
							cOutString = [<TD>]+zy+[</TD>]//OEM(cOutString)
*/						endif
					endif
			 	endcase
				fOutFile.puts( cOutString ) 
			next

			// end row tag:
			cOutString = "</TR>"
			fOutFile.puts( cOutString )

			// next row
			r.next()

		enddo

		// close the HTML table
		cOutString = "</TABLE></CENTER>"
		fOutFile.puts( cOutString )
		// end of the body of the file
		cOutString = "</BODY>"
		fOutFile.puts( cOutString )
		// closing HTML tag
		cOutString = "</HTML>"
		fOutFile.puts( cOutString )

		// close output file
		fOutFile.close()
return


function getfilenameonly (cobj)
	// function for splitting a returned full tablename
	// returns the name of the table without path and extension
		local nPos, nEPos, cfile
		cfile=cobj
		nPos = rat( "\", cfile  )
		nEPos= rat( ".", cfile  )
		if nPos >= 0  and nEPOS > 0
			cfile = substr( cfile, ++nPos, nEPOS - nPos )
		else
			cfile = ""
		endif
		return cfile

